/**************************************************************************
 *
 *  This file is part of the Coin GUI binding libraries.
 *  Copyright (C) 2000 by Systems in Motion.  All rights reserved.
 *
 *  The libraries this file is part of is free software; you can
 *  redistribute them and/or modify them under the terms of the GNU
 *  Lesser General Public License version 2.1 as published by the
 *  Free Software Foundation.  See the file LICENSE.LGPL at the root
 *  directory of the distribution for all the details.
 *
 *  If you want to use the Coin GUI binding libraries for applications
 *  not compatible with the LGPL, contact SIM about acquiring a
 *  Professional Edition License.
 *
 *  Systems in Motion, Prof Brochs gate 6, N-7030 Trondheim, NORWAY
 *  http://www.sim.no/ support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
 **************************************************************************/

// Generated automatically from SoGuiRenderArea.h.in by configure.
// $Id: SoGuiRenderArea.h.in,v 1.8 2000/09/11 14:58:47 larsa Exp $

#ifndef SOQT_RENDERAREA_H
#define SOQT_RENDERAREA_H

/**************************************************************************\
 *
 *  A WORD OF ADVICE
 *
 *  It is fruitless to modify the contents of the SoQtRenderArea.h file
 *  because it is autogenerated by configure from the SoGuiRenderArea.h.in
 *  file which you will find in the src/Inventor/Qt/common/ directory.
 *  Do your modifications to that file instead.
 *
\**************************************************************************/

#include <Inventor/SbColor.h>
#include <Inventor/SbViewportRegion.h>
#include <Inventor/actions/SoGLRenderAction.h>
// This include is present for compliance with the original Open
// Inventor.
#include <Inventor/SoSceneManager.h>

#include <Inventor/Qt/SoQtGLWidget.h>

class SbColor;
class SoNode;
class SoSelection;
class SoSceneManager;

class SoQtDevice;
class SoQtKeyboard;
class SoQtMouse;

#define SO_GL_DEFAULT_MODE (SO_GL_RGB | SO_GL_ZBUFFER | SO_GL_DOUBLE)

// *************************************************************************

typedef SbBool SoQtRenderAreaEventCB( void * user, QEvent * event );

class SOQT_DLL_EXPORT SoQtRenderArea : public SoQtGLWidget {
  typedef SoQtGLWidget inherited;
  Q_OBJECT

public:
  SoQtRenderArea(
    QWidget * parent = NULL,
    const char * name = NULL,
    SbBool embed = TRUE,
    SbBool mouseInput = TRUE,
    SbBool keyboardInput = TRUE );
#if SOQT_HAVE_WINWIDGET
  SoQtRenderArea(
    @WINWIDGET@ parent = NULL,
    const char * name = NULL,
    SbBool embed = TRUE,
    SbBool mouseInput = TRUE,
    SbBool keyboardInput = TRUE );
#endif // SOQT_HAVE_WINWIDGET
  ~SoQtRenderArea(void);

  virtual void setSceneGraph( SoNode * scene );
  virtual SoNode * getSceneGraph(void);
  void setOverlaySceneGraph( SoNode * scene );
  SoNode * getOverlaySceneGraph(void);
  void registerDevice( SoQtDevice * device );
  void unregisterDevice( SoQtDevice * device );
  void setBackgroundColor( const SbColor & color );
  const SbColor & getBackgroundColor(void) const;
  void setBackgroundIndex( int idx );
  int getBackgroundIndex(void) const;
  void setOverlayBackgroundIndex( int idx );
  int getOverlayBackgroundIndex(void) const;
  void setColorMap( int start, int num, const SbColor * colors );
  void setOverlayColorMap( int start, int num, const SbColor * colors );
  void setViewportRegion( const SbViewportRegion & newRegion );
  const SbViewportRegion & getViewportRegion(void) const;
  void setTransparencyType( SoGLRenderAction::TransparencyType type );
  SoGLRenderAction::TransparencyType getTransparencyType(void) const;
  void setAntialiasing( SbBool smoothing, int numPasses );
  void getAntialiasing( SbBool & smoothing, int & numPasses ) const;
  void setClearBeforeRender( SbBool enable, SbBool zbEnable = TRUE );
  SbBool isClearBeforeRender(void) const;
  SbBool isClearZBufferBeforeRender(void) const;
  void setClearBeforeOverlayRender( SbBool enable );
  SbBool isClearBeforeOverlayRender(void) const;
  void setAutoRedraw( SbBool enable );
  SbBool isAutoRedraw(void) const;
  void setRedrawPriority( uint32_t priority );
  uint32_t getRedrawPriority(void) const;
  static uint32_t getDefaultRedrawPriority(void);
  void render(void);
  void renderOverlay(void);
  void scheduleRedraw(void);
  void scheduleOverlayRedraw(void);
  void redrawOnSelectionChange( SoSelection * selection );
  void redrawOverlayOnSelectionChange( SoSelection * selection );
  void setEventCallback( SoQtRenderAreaEventCB * func, void * user = NULL );
  void setSceneManager( SoSceneManager * manager );
  SoSceneManager * getSceneManager(void) const;
  void setOverlaySceneManager( SoSceneManager * manager );
  SoSceneManager * getOverlaySceneManager(void) const;
  void setGLRenderAction( SoGLRenderAction * action );
  SoGLRenderAction * getGLRenderAction(void) const;
  void setOverlayGLRenderAction( SoGLRenderAction * action );
  SoGLRenderAction * getOverlayGLRenderAction(void) const;

protected:
  SoQtRenderArea(
    QWidget * parent,
    const char * name,
    SbBool embed,
    SbBool mouseInput,
    SbBool keyboardInput,
    SbBool build );
#if SOQT_HAVE_WINWIDGET
  SoQtRenderArea(
    @WINWIDGET@ parent,
    const char * name,
    SbBool embed,
    SbBool mouseInput,
    SbBool keyboardInput,
    SbBool build );
#endif // SOQT_HAVE_WINWIDGET

  virtual void redraw(void);
  virtual void actualRedraw(void);
  virtual void redrawOverlay(void);
  virtual void actualOverlayRedraw(void);

  virtual SbBool processSoEvent( const SoEvent * const event );
  virtual void processEvent( QEvent * event );
  virtual void initGraphic(void);
  virtual void initOverlayGraphic(void);
  virtual void sizeChanged( const SbVec2s size );
  virtual void widgetChanged( QWidget * widget );

  QWidget * buildWidget( QWidget * parent );
#if SOQT_HAVE_WINWIDGET
  QWidget * buildWidget( @WINWIDGET@ parent );
#endif // SOQT_HAVE_WINWIDGET

  virtual const char * getDefaultWidgetName(void) const;
  virtual const char * getDefaultTitle(void) const;
  virtual const char * getDefaultIconTitle(void) const;

  SoQtRenderAreaEventCB * appEventHandler;
  void * appEventHandlerData;

  SbBool invokeAppCB( QEvent * event );

  virtual void glInit(void);
  virtual void glReshape( int width, int height );
  virtual void glRender(void);

  const SoEvent * getSoEvent( QEvent * event );

private:
  void constructor( SbBool mouseInput, SbBool keyboardInput, SbBool build );
  void setDevicesWindowSize( const SbVec2s size );

  static void renderCB( void * user, SoSceneManager * manager );

  SbBool clear;
  SbBool clearZBuffer;
  SbBool clearOverlay;

  SoSceneManager * normalManager;
  SoSceneManager * overlayManager;

  SbColor * normalColormap;
  int normalColormapSize;
  int normalColormapStart;
  SbColor * overlayColormap;
  int overlayColormapSize;
  int overlayColormapStart;

  struct {
    SoQtKeyboard * keyboard;
    SoQtMouse * mouse;
    SbPList * extra;
  } devices;

  SbBool autoRedraw;

  SoSelection * normalSelection;
  SoSelection * overlaySelection;

}; // class SoQtRenderArea

// *************************************************************************

#endif // ! SOQT_RENDERAREA_H
