/**************************************************************************
 *
 *  This file is part of the Coin GUI binding libraries.
 *  Copyright (C) 2000 by Systems in Motion.  All rights reserved.
 *
 *  The libraries this file is part of is free software; you can
 *  redistribute them and/or modify them under the terms of the GNU
 *  Lesser General Public License version 2.1 as published by the
 *  Free Software Foundation.  See the file LICENSE.LGPL at the root
 *  directory of the distribution for all the details.
 *
 *  If you want to use the Coin GUI binding libraries for applications
 *  not compatible with the LGPL, contact SIM about acquiring a
 *  Professional Edition License.
 *
 *  Systems in Motion, Prof Brochs gate 6, N-7030 Trondheim, NORWAY
 *  http://www.sim.no/ support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
 **************************************************************************/

// Generated automatically from SoAnyPlaneViewer.h.in by configure.
// $Id: SoAnyPlaneViewer.h.in,v 1.10 2000/09/11 14:58:47 larsa Exp $

#ifndef SOANY_PLANEVIEWER_H
#define SOANY_PLANEVIEWER_H

#include <Inventor/SbLinear.h>

class SoCamera;
class SoEvent;

class SoQtPlaneViewer;

// ************************************************************************

class SoAnyPlaneViewer {
public:
  SoAnyPlaneViewer( SoQtPlaneViewer * const viewer );
  ~SoAnyPlaneViewer(void);

  void translateX( const float delta ) const;
  void translateY( const float delta ) const;
  void rotateZ( const float angle ) const;

  void viewPlaneX(void) const;
  void viewPlaneY(void) const;
  void viewPlaneZ(void) const;

  void setCanvasSize( const SbVec2s size );
  void setPointerLocation( const SbVec2s location );
  int getPointerXMotion(void) const;
  int getPointerYMotion(void) const;
  float getPointerOrigoAngle(void) const;
  float getPointerOrigoMotionAngle(void) const;

  void drawRotateGraphics(void) const;

  void viewPlaneX( SoCamera * const camera );
  void viewPlaneY( SoCamera * const camera );
  void viewPlaneZ( SoCamera * const camera );

  SbBool processSoEvent( const SoEvent * const event );

private:
  SoQtPlaneViewer * const viewer;

  struct pointerdata {
    SbVec2s now;
    SbVec2s then;
  } pointer;
  SbVec2s canvas;

}; // class SoAnyPlaneViewer

// ************************************************************************

#endif // ! SOANY_PLANEVIEWER_H
